//=====================================================================================================
//                                      M400, M100 2-wire                                                   
//=====================================================================================================
//                                                                                                     
//! file                                                                                      
//!                                                                                                    
//! brief      str file                                                                                       
//!                                                                                                    
//!                                                                                                    
//! (c) Copyright 2004-2016 Mettler-Toledo All Rights Reserved                                         
//! author                                                                          
//                                                                                                     
// $Date: 
// $State: Exp $:
// $Revision: 
//
//=============================================================================

#define SENSOR_CHANNEL_DIGITAL (sensorChannel == 1)
#define SENSOR_CHANNEL_ANALOG  (sensorChannel == 0)


#define SENSOR_PH_ALL ((sensortype_without_auto == 0) || (sensortype_without_auto == 14) )
#define SENSOR_O2 ((sensortype_without_auto == 1) || (sensortype_without_auto == 2) || (sensortype_without_auto == 3))
#define SENSOR_ODO (sensortype_without_auto == 12)
#define SENSOR_Cond ((sensortype_without_auto == 5) || (sensortype_without_auto == 7) || (sensortype_without_auto == 8))
#define SENSOR_INPRO5000I (sensortype_without_auto == 16)
#define SENSOR_INPRO5500I (sensortype_without_auto == 17)
#define SENSOR_TDL (sensortype_without_auto == 21)
#define SENSOR_TOC (sensortype_without_auto == 4)
#define SENSOR_OZONE (sensortype_without_auto == 13)

#define SENSOR_UNICOND (sensortype_without_auto == 5)
#define SENSOR_ING_RS485 ((sensortype_without_auto == 12)||(sensortype_without_auto == 17)||(sensortype_without_auto == 21))

#define SENSOR_PH_ORP (sensortype_without_auto == 0)
#define SENSOR_ISM_PNA (sensortype_without_auto == 14)


#define DEFAULT_SENSORTYPE      0

#if 1
#define IS_ONLINE_MODE  		(HART_Online_Actived == 1)
#define IS_OFFLINE_MODE  		(HART_Online_Actived == 0)
#else
//for debug using only,special testing
#define IS_ONLINE_MODE  		(HART_Online_Actived == 0)
#define IS_OFFLINE_MODE  		(HART_Online_Actived == 1)
#endif


//device_specific_status_5

#if 1
#define ISM_SENSOR_CONNECTED    ((ISM_Connected_Status == 1)&&((device_specific_status_5&0x01) == 0))
//#define ISM_SENSOR_CONNECTED    ((ISM_Connected_Status== 1))

#else		
//for debug using only,special testing
#define ISM_SENSOR_CONNECTED    (ISM_Connected_Status == 0)
#endif

#define RES_SUCCESS 									0
#define RES_INVALID_SELECTION 				2
#define RES_PARAM_TOO_LARGE 					3
#define RES_PARAM_TOO_SMALL 					4
#define RES_TOO_FEW_DATA 							5
#define RES_DEVICE_SPEC_CMD_ERROR			6
#define RES_IN_WRITE_PROTECT 					7
#define RES_ACCESS_RESTRICTED				 16
#define RES_DEVICE_BUSY							 32
#define RES_CMD_NOT_IMPL						 64

#define DEF_COMMON_CMD_SETTING(NUMBER_OF_RETRIES) \
                SET_NUMBER_OF_RETRIES(NUMBER_OF_RETRIES); \
                RETRY_ON_NO_DEVICE(); \
                IGNORE_ALL_RESPONSE_CODES(); \
                IGNORE_ALL_DEVICE_STATUS(); \
                XMTR_IGNORE_ALL_RESPONSE_CODES(); \
                XMTR_IGNORE_ALL_DEVICE_STATUS();

#define SEND_CMD_AND_CHECK_STATUS(CMD_NUM) send(CMD_NUM, status); \
		if(status[STATUS_RESPONSE_CODE] != RES_SUCCESS) \
		{ if((status[STATUS_RESPONSE_CODE] == RES_INVALID_SELECTION) \
			|| (status[STATUS_RESPONSE_CODE] == RES_PARAM_TOO_LARGE) \
			|| (status[STATUS_RESPONSE_CODE] == RES_PARAM_TOO_SMALL) \
			|| (status[STATUS_RESPONSE_CODE] == RES_TOO_FEW_DATA) \
			|| (status[STATUS_RESPONSE_CODE] == RES_DEVICE_SPEC_CMD_ERROR) \
			|| (status[STATUS_RESPONSE_CODE] == RES_IN_WRITE_PROTECT) \
			|| (status[STATUS_RESPONSE_CODE] == RES_ACCESS_RESTRICTED)) \
			{ display_response_status(CMD_NUM, status[STATUS_RESPONSE_CODE]);}}


// ISM_Func1_Flags
#define ISM_FUNC_CIP     		(1<<0)
#define ISM_FUNC_SIP			(1<<1)
#define ISM_FUNC_AUTOCLAVE		(1<<2)
#define ISM_FUNC_TTM			(1<<3)
#define ISM_FUNC_ACT			(1<<4)
#define ISM_FUNC_DLI			(1<<5)
#define ISM_FUNC_CIP_RESET		(1<<6)
#define ISM_FUNC_SIP_RESET		(1<<7)
#define ISM_FUNC_AUTOCLAVE_RESET	(1<<8)
#define ISM_FUNC_TTM_RESET		(1<<9)
#define ISM_FUNC_Electrolyte	(1<<10)
#define ISM_FUNC_DLI_RESET		(1<<11)
#define ISM_FUNC_PH_STRESS		(1<<12)
#define ISM_FUNC_OPERATION_DAY	(1<<13)
#define ISM_FUNC_MAX_TEMP		(1<<14)
#define ISM_FUNC_MAX_TEMP_DATE	(1<<15)
#define ISM_FUNC_SAN			(1<<16)
#define ISM_FUNC_UNICOND		(1<<17)
#define ISM_FUNC_DLI_Leaning    (1<<18)
#define ISM_FUNC_Rg_Rr          (1<<19)
#define ISM_FUNC_Rg_RgpNa       (1<<20)
#define ISM_FUNC_Tspot          (1<<21)



#define MT_MEAS_UNITS \
    { 170,      [mg_l],             [mg_l_help] },                  \
    { 171,      "Ohm*cm",           "Ohm*cm" },               		\
    { 172,      "KOhm*cm",           "KOhm*cm" },               	\
    { 173,      [mega_ohmCm],       [mega_ohm_centimeter_help] },   \
    { 174,      [hPa],              [hPa_help] },                   \
    { 240,      "   ",              "const value" },                \
    { 241,      [mega_ohm],         [mega_ohm_help] },              \
    { 242,      [ppth],             [ppth_help] },                  \
    { 243,      "nA",               "nano ampere helps" },          \
    { 244,      "V/V",              "V/V" },          				\
    { 245,      "g/100ml",          " " },          				\
    ALL_UNITS  

#define MT_CAL_UNITS \
    { 171,      "Ohm*cm",           "Ohm*cm" },               		\
    { 172,      "KOhm*cm",           "KOhm*cm" },               	\
    { 240,      "   ",              "no unit" },               		\
    { 241,      "mV/pH",            "mV/pH" },               		\
    { 242,      "/cm",             	"/cm" },               			\
    { 243,      "nA",               "nano ampere helps" },			\
    { 244,      "nA/ppb",           "nA/ppb" },						\
    { 245,      "ORP",           	"ORP" },						\
    { 246,      "%V",           	"%V" },							\
	ALL_UNITS 

#define  MT_UNITS_LIST \
	{0, "degC"},\
	{1, "degF"},\
	{2, "None"},\
	{3, "DLI"},\
	{4, "TTM"},\
	{5, "ACT"},\
	{6, "pH"},\
	{7, "pH mV"},\
	{8, "ORP"},\
	{9, "Rg"},\
	{10, "RpNa"},\
	{11, "Rr"},\
	{17, "%air"},\
	{12, "mg/L"},\
	{13, "ug/L"},\
	{14, "ppm"},\
	{15, "ppb"},\
	{20, "nA"},\
    {16, "%O2"},\
	{18, "%O2G"},\
	{19, "ppmO2G"},\
	{21, "ProcPress"},\
	{25, "mS/cm"},\
	{26, "uS/cm"},\
	{27, "MOhm*cm"},\
	{28, "KOhm*cm"},\
	{29, "Ohm*cm"},\
	{30, "TDS NaCl(ppm)"},\
	{31, "TDS NaCl(ppb)"},\
	{32, "TDS NaCl(ppk)"},\
	{33, "TDS CaCO3(ppm)"},\
	{34, "TDS CaCO3(ppb)"},\
	{35, "TDS CaCO3(ppk)"},\
	{36, "%NaOH"},\
	{37, "%NaCl"},\
	{38, "%H2SO4"},\
	{39, "%H3PO4"},\
	{40, "%HNO3"},\
	{41, "%HCl"},\
	{24, "%Conc"},\
	{42, "ppm G1"},\
	{43, "%V G1"},\
	{44, "ppm G2"},\
	{45, "%V G2"},\
	{46, "NSL"},\
	{47, "%Trm"},\
	{48, "%CO2"},\
	{49, "CO2 mg/L"},\
	{50, "CO2 mV"},\
	{51, "CO2 g/L"},\
	{52, "V/V"},\
	{53, "g/100mL"},\
	{100, "hPa"},\
	{101, "mbar"},\
	{102, "mmHg"},\
	{103, "kPa"},\
	{104, "psi"}\


#define  DEF_RESOLUTION(var)\
                SELECT(var)\
		{	CASE 0: ".0f";CASE 1: ".1f";CASE 2: ".2f";CASE 3: ".3f";CASE 4: ".4f";CASE 5: ".5f";DEFAULT:".4f";}


